import { Driver } from "../../driver/Driver";
import { RelationIdAttribute } from "../RelationIdAttribute";
import { QueryExpressionMap } from "../QueryExpressionMap";
/**
 * Transforms raw sql results returned from the database into entity object.
 * Entity is constructed based on its entity metadata.
 */
export declare class RawSqlResultsToEntityTransformer {
    private driver;
    private expressionMap;
    rawRelationIdResults: {
        relationIdAttribute: RelationIdAttribute;
        results: any[];
    }[];
    constructor(driver: Driver, expressionMap: QueryExpressionMap);
    transform(rawSqlResults: any[], rawRelationIdResults: {
        relationIdAttribute: RelationIdAttribute;
        results: any[];
    }[]): any[];
    /**
     * Since db returns a duplicated rows of the data where accuracies of the same object can be duplicated
     * we need to group our result and we must have some unique id (primary key in our case)
     */
    private groupAndTransform(rawSqlResults, alias, metadata);
    /**
     * Transforms set of data results into single entity.
     */
    private transformIntoSingleResult(rawSqlResults, alias, metadata);
}
